package com.its.api.its.service.vms;

import com.its.api.its.model.dto.vms.TbVmsSttsHsDto;
import com.its.api.its.model.entity.vms.TbVmsSttsHs;
import com.its.api.its.model.entity.vms.TbVmsSttsHsKey;
import com.its.api.its.repository.vms.TbVmsSttsHsRepository;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbVmsSttsHsService {

    private final TbVmsSttsHsRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbVmsSttsHs requireOne(TbVmsSttsHsKey id) {
        return this.repo.findById(id)
                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbVmsSttsHsDto> findAll() {
        List<TbVmsSttsHsDto> result = new ArrayList<>();
        List<TbVmsSttsHs> data = this.repo.findAll();
        for (TbVmsSttsHs entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbVmsSttsHsDto findById(TbVmsSttsHsKey id) {
        TbVmsSttsHs entity = requireOne(id);
        return entity.toDto();
    }

    /**
     * 상태 이력 조회
     * @param fromDt
     * @param toDt
     * @param ids
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbVmsSttsHsDto> findAllByDateRange(String fromDt, String toDt, List<Long> ids) {

        List<TbVmsSttsHsDto> result = new ArrayList<>();
        List<TbVmsSttsHs> data = this.repo.findAllByDateRange(fromDt, toDt, ids);
        if (data != null) {
            data.forEach(obj -> {
                if (obj.getVms() != null && ("N").equals(obj.getVms().getDelYn())) {
                    result.add(obj.toDto());
                }
            });
        }
        return result;
    }

    /**
     * 장애 이력 조회
     * @param fromDt
     * @param toDt
     * @param ids
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbVmsSttsHsDto> findAllFailByDateRange(String fromDt, String toDt, List<Long> ids) {

        List<TbVmsSttsHsDto> result = new ArrayList<>();
        List<TbVmsSttsHs> data = this.repo.findAllFailByDateRange(fromDt, toDt, ids);
        if (data != null) {
            data.forEach(obj -> {
                if (obj.getVms() != null && ("N").equals(obj.getVms().getDelYn())) {
                    result.add(obj.toDto());
                }
            });
        }
        return result;
    }
}
